library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity adder32 is
	port (
		a : in std_logic_vector (31 downto 0) ;
		b : in std_logic_vector (31 downto 0) ;
		cin : in std_logic ;
		s : out std_logic_vector (31 downto 0) ;
		cout : out std_logic
	);
end adder32;

architecture synthesis of adder32 is

	-- submodules declarations
	component fulladder
		port (
			ai : in std_logic ;
			bi : in std_logic ;
			cin : in std_logic ;
			si : out std_logic ;
			cout : out std_logic
		) ;
	end component ;

	-- internal signals declarations
	signal c : std_logic_vector (31 downto 1) ;

begin

	-- components instanciations
	fulladder_0 : fulladder port map (a(0), b(0), cin, s(0), c(1)) ;
	fulladder_1 : fulladder port map (a(1), b(1), c(1), s(1), c(2)) ;
	fulladder_2 : fulladder port map (a(2), b(2), c(2), s(2), c(3)) ;
	fulladder_3 : fulladder port map (a(3), b(3), c(3), s(3), c(4)) ;
	fulladder_4 : fulladder port map (a(4), b(4), c(4), s(4), c(5)) ;
	fulladder_5 : fulladder port map (a(5), b(5), c(5), s(5), c(6)) ;
	fulladder_6 : fulladder port map (a(6), b(6), c(6), s(6), c(7)) ;
	fulladder_7 : fulladder port map (a(7), b(7), c(7), s(7), c(8)) ;
	fulladder_8 : fulladder port map (a(8), b(8), c(8), s(8), c(9)) ;
	fulladder_9 : fulladder port map (a(9), b(9), c(9), s(9), c(10)) ;
	fulladder_10 : fulladder port map (a(10), b(10), c(10), s(10), c(11)) ;
	fulladder_11 : fulladder port map (a(11), b(11), c(11), s(11), c(12)) ;
	fulladder_12 : fulladder port map (a(12), b(12), c(12), s(12), c(13)) ;
	fulladder_13 : fulladder port map (a(13), b(13), c(13), s(13), c(14)) ;
	fulladder_14 : fulladder port map (a(14), b(14), c(14), s(14), c(15)) ;
	fulladder_15 : fulladder port map (a(15), b(15), c(15), s(15), c(16)) ;
	fulladder_16 : fulladder port map (a(16), b(16), c(16), s(16), c(17)) ;
	fulladder_17 : fulladder port map (a(17), b(17), c(17), s(17), c(18)) ;
	fulladder_18 : fulladder port map (a(18), b(18), c(18), s(18), c(19)) ;
	fulladder_19 : fulladder port map (a(19), b(19), c(19), s(19), c(20)) ;
	fulladder_20 : fulladder port map (a(20), b(20), c(20), s(20), c(21)) ;
	fulladder_21 : fulladder port map (a(21), b(21), c(21), s(21), c(22)) ;
	fulladder_22 : fulladder port map (a(22), b(22), c(22), s(22), c(23)) ;
	fulladder_23 : fulladder port map (a(23), b(23), c(23), s(23), c(24)) ;
	fulladder_24 : fulladder port map (a(24), b(24), c(24), s(24), c(25)) ;
	fulladder_25 : fulladder port map (a(25), b(25), c(25), s(25), c(26)) ;
	fulladder_26 : fulladder port map (a(26), b(26), c(26), s(26), c(27)) ;
	fulladder_27 : fulladder port map (a(27), b(27), c(27), s(27), c(28)) ;
	fulladder_28 : fulladder port map (a(28), b(28), c(28), s(28), c(29)) ;
	fulladder_29 : fulladder port map (a(29), b(29), c(29), s(29), c(30)) ;
	fulladder_30 : fulladder port map (a(30), b(30), c(30), s(30), c(31)) ;
	fulladder_31 : fulladder port map (a(31), b(31), c(31), s(31), cout) ;

end synthesis;
