library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity cpt2 is
	port (
		clk : in std_logic ;
		rst : in std_logic ;
		x : out std_logic_vector (1 downto 0)
	);
end cpt2;

architecture synthesis of cpt2 is

	-- buffer signals declarations
	signal x_int : std_logic_vector (1 downto 0) ;

	-- internal signals declarations
	signal x_t : std_logic_vector (1 downto 0) ;

begin

	-- buffer signals assignations
	x(1 downto 0) <= x_int(1 downto 0) ;

	-- concurrent statements
	x_t(0) <= '1' ;
	x_t(1) <= x_int(0) ;

	-- sequential statements
	process (clk, rst) begin
		if rst = '1' then
			x_int(1 downto 0) <= "00" ;
		elsif clk'event and clk = '1' then
			x_int(1 downto 0) <= (x_t(1 downto 0) and (not x_int(1 downto 0))) or ((not x_t(1 downto 0)) and x_int(1 downto 0)) ;
		end if ;
	end process ;

end synthesis;
