library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity fulladder is
	port (
		ai : in std_logic ;
		bi : in std_logic ;
		cin : in std_logic ;
		si : out std_logic ;
		cout : out std_logic
	);
end fulladder;

architecture synthesis of fulladder is

	-- submodules declarations
	component XORCY
		port (
			CI   : in std_logic ;
			LI   : in std_logic ;
			O    : out std_logic
		) ;
	end component ;
	component MUXCY
		port (
			DI   : in std_logic ;
			CI   : in std_logic ;
			S    : in std_logic ;
			O    : out std_logic
		) ;
	end component ;

	-- internal signals declarations
	signal xi : std_logic ;

begin

	-- concurrent statements
	xi <= (ai and (not bi)) or ((not ai) and bi) ;

	-- components instanciations
	XORCY_0 : XORCY port map (cin, xi, si) ;
	MUXCY_1 : MUXCY port map (ai, cin, xi, cout) ;

end synthesis;
