library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity zero32 is
	port (
		a : in std_logic_vector (31 downto 0) ;
		z : out std_logic
	);
end zero32;

architecture synthesis of zero32 is

	-- submodules declarations
	component zero6
		port (
			a : in std_logic_vector (5 downto 0) ;
			zero : out std_logic
		) ;
	end component ;
	component zero2
		port (
			a : in std_logic_vector (1 downto 0) ;
			zero : out std_logic
		) ;
	end component ;

	-- internal signals declarations
	signal za0 : std_logic ;
	signal za1 : std_logic ;
	signal za2 : std_logic ;
	signal za3 : std_logic ;
	signal za4 : std_logic ;
	signal za5 : std_logic ;

begin

	-- concurrent statements
	z <= za0 and za1 and za2 and za3 and za4 and za5 ;

	-- components instanciations
	zero6_0 : zero6 port map (a(5 downto 0), za0) ;
	zero6_1 : zero6 port map (a(11 downto 6), za1) ;
	zero6_2 : zero6 port map (a(17 downto 12), za2) ;
	zero6_3 : zero6 port map (a(23 downto 18), za3) ;
	zero6_4 : zero6 port map (a(29 downto 24), za4) ;
	zero2_5 : zero2 port map (a(31 downto 30), za5) ;

end synthesis;
